// Generated by 'yaml2podo'
// Version: 0.1.17
// https://pub.dev/packages/yaml2podo

class Alias {
  final String clazz;

  Alias({this.clazz});

  factory Alias.fromJson(Map map) {
    return Alias(clazz: map['class'] as String);
  }

  Map<String, dynamic> toJson() {
    return {
      'class': clazz,
    };
  }
}

class Bar {
  final int i;

  Bar({this.i});

  factory Bar.fromJson(Map map) {
    return Bar(i: map['i'] as int);
  }

  Map<String, dynamic> toJson() {
    return {
      'i': i,
    };
  }
}

class EmptyObject {
  EmptyObject();

  factory EmptyObject.fromJson(Map map) {
    return EmptyObject();
  }

  Map<String, dynamic> toJson() {
    return {};
  }
}

class Foo {
  final Map<String, Bar> bars;

  Foo({this.bars});

  factory Foo.fromJson(Map map) {
    return Foo(bars: _toMap(map['bars'], (e) => Bar.fromJson(e as Map)));
  }

  Map<String, dynamic> toJson() {
    return {
      'bars': _fromMap(bars, (e) => e.toJson()),
    };
  }
}

class ObjectWithObjects {
  final List<Object> list;
  final Map<String, Object> map;

  ObjectWithObjects({this.list, this.map});

  factory ObjectWithObjects.fromJson(Map map) {
    return ObjectWithObjects(
        list: _toList(map['list'], (e) => e),
        map: _toMap(map['map'], (e) => e));
  }

  Map<String, dynamic> toJson() {
    return {
      'list': _fromList(list, (e) => e),
      'map': _fromMap(map, (e) => e),
    };
  }
}

class Order {
  final double amount;
  final DateTime date;
  final bool isShipped;
  final List<OrderItem> items;

  Order({this.amount, this.date, this.isShipped, this.items});

  factory Order.fromJson(Map map) {
    return Order(
        amount: _toDouble(map['amount']),
        date: _toDateTime(map['date']),
        isShipped: map['is_shipped'] as bool,
        items: _toList(map['items'], (e) => OrderItem.fromJson(e as Map)));
  }

  Map<String, dynamic> toJson() {
    return {
      'amount': amount,
      'date': _fromDateTime(date),
      'is_shipped': isShipped,
      'items': _fromList(items, (e) => e.toJson()),
    };
  }
}

class OrderItem {
  final num price;
  final Product product;
  final int quantity;

  OrderItem({this.price, this.product, this.quantity});

  factory OrderItem.fromJson(Map map) {
    return OrderItem(
        price: map['price'] as num,
        product: _toObject(map['product'], (e) => Product.fromJson(e as Map)),
        quantity: map['quantity'] as int);
  }

  Map<String, dynamic> toJson() {
    return {
      'price': price,
      'product': product?.toJson(),
      'quantity': quantity,
    };
  }
}

class Product {
  final int id;
  final String name;

  Product({this.id, this.name});

  factory Product.fromJson(Map map) {
    return Product(id: map['id'] as int, name: map['name'] as String);
  }

  Map<String, dynamic> toJson() {
    return {
      'id': id,
      'name': name,
    };
  }
}

class Super {
  final bool boolean;
  final DateTime date;
  final double float;
  final Foo foo;
  final Foo foo2;
  final int integer;
  final List<Map<String, Bar>> list;
  final Map<String, List<Bar>> map;
  final Map<String, List<int>> map2;
  final String string;

  Super(
      {this.boolean,
      this.date,
      this.float,
      this.foo,
      this.foo2,
      this.integer,
      this.list,
      this.map,
      this.map2,
      this.string});

  factory Super.fromJson(Map map) {
    return Super(
        boolean: map['boolean'] as bool,
        date: _toDateTime(map['date']),
        float: _toDouble(map['float']),
        foo: _toObject(map['foo'], (e) => Foo.fromJson(e as Map)),
        foo2: _toObject(map['foo2'], (e) => Foo.fromJson(e as Map)),
        integer: map['integer'] as int,
        list: _toList(
            map['list'], (e) => _toMap(e, (e) => Bar.fromJson(e as Map))),
        map: _toMap(
            map['map'], (e) => _toList(e, (e) => Bar.fromJson(e as Map))),
        map2: _toMap(map['map2'], (e) => _toList(e, (e) => e as int)),
        string: map['string'] as String);
  }

  Map<String, dynamic> toJson() {
    return {
      'boolean': boolean,
      'date': _fromDateTime(date),
      'float': float,
      'foo': foo?.toJson(),
      'foo2': foo2?.toJson(),
      'integer': integer,
      'list': _fromList(list, (e) => _fromMap(e, (e) => e.toJson())),
      'map': _fromMap(map, (e) => _fromList(e, (e) => e.toJson())),
      'map2': _fromMap(map2, (e) => _fromList(e, (e) => e)),
      'string': string,
    };
  }
}

String _fromDateTime(dynamic data) {
  if (data == null) {
    return null;
  }
  if (data is DateTime) {
    return data.toIso8601String();
  }
  return data as String;
}

List _fromList(dynamic data, dynamic Function(dynamic) toJson) {
  if (data == null) {
    return null;
  }
  var result = [];
  for (var element in data) {
    var value;
    if (element != null) {
      value = toJson(element);
    }
    result.add(value);
  }
  return result;
}

Map<String, dynamic> _fromMap(dynamic data, dynamic Function(dynamic) toJson) {
  if (data == null) {
    return null;
  }
  var result = <String, dynamic>{};
  for (var key in data.keys) {
    var value;
    var element = data[key];
    if (element != null) {
      value = toJson(element);
    }
    result[key.toString()] = value;
  }
  return result;
}

DateTime _toDateTime(dynamic data) {
  if (data == null) {
    return null;
  }
  if (data is String) {
    return DateTime.parse(data);
  }
  return data as DateTime;
}

double _toDouble(dynamic data) {
  if (data == null) {
    return null;
  }
  if (data is int) {
    return data.toDouble();
  }
  return data as double;
}

List<T> _toList<T>(dynamic data, T Function(dynamic) fromJson) {
  if (data == null) {
    return null;
  }
  var result = <T>[];
  for (var element in data) {
    T value;
    if (element != null) {
      value = fromJson(element);
    }
    result.add(value);
  }
  return result;
}

Map<K, V> _toMap<K extends String, V>(
    dynamic data, V Function(dynamic) fromJson) {
  if (data == null) {
    return null;
  }
  var result = <K, V>{};
  for (var key in data.keys) {
    V value;
    var element = data[key];
    if (element != null) {
      value = fromJson(element);
    }
    result[key.toString() as K] = value;
  }
  return result;
}

T _toObject<T>(dynamic data, T Function(dynamic) fromJson) {
  if (data == null) {
    return null;
  }
  return fromJson(data);
}

/*
Alias:
  clazz.class: String
Bar:
  i: int
Foo:
  bars: Map<String, Bar>
Order:
  amount: double
  date: DateTime
  items: List<OrderItem>
  is_shipped: bool
OrderItem:
  product: Product
  quantity: int
  price: num
Product:
  id: int
  name: String
ObjectWithObjects:
  list: List<Object>
  map: Map<String, Object>
Super:
  boolean: bool
  date: DateTime 
  float: double
  foo: Foo
  foo2: Foo
  integer: int
  string: String
  list: List<Map<String, Bar>>
  map: Map<String, List<Bar>>
  map2: Map<String, List<int>>
EmptyObject:
*/
